#property indicator_separate_window
//#property indicator_maximum 2
//#property indicator_minimum -2
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red
//#property indicator_color3 DodgerBlue
//#property indicator_color4 Yellow
//#property indicator_level1 0
//#property indicator_levelcolor 1776411
//#property indicator_levelstyle 0

enum ma_pr{tied,proportional,free};
input ma_pr          Ma_pr   = tied;
input int            Ma      = 9;

int ma0,ma1,ma2,ma3;

double B0[],B1[],Bp0[], Bp1[], Bp2[], Bp3[], Bp4[], Bp5[], Bp6[], Bp7[],
                 B1m0[],B1m1[],B1m2[],B1m3[],B1m4[],B1m5[],B1m6[],B1m7[],
                 B2m0[],B2m1[],B2m2[],B2m3[],B2m4[],B2m5[],B2m6[],B2m7[],
                 B3m0[],B3m1[],B3m2[],B3m3[],B3m4[],B3m5[],B3m6[],B3m7[],
                 B4m0[],B4m1[],B4m2[],B4m3[],B4m4[],B4m5[],B4m6[],B4m7[];

int init() {
   IndicatorBuffers(42);
   SetIndexBuffer(0,B0); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,B1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Bp0);   SetIndexBuffer(3,Bp1);   SetIndexBuffer(4,Bp2);   SetIndexBuffer(5,Bp3);   SetIndexBuffer(6,Bp4);   SetIndexBuffer(7,Bp5);   SetIndexBuffer(8,Bp6);   SetIndexBuffer(9,Bp7);
   SetIndexBuffer(10,B1m0); SetIndexBuffer(11,B1m1); SetIndexBuffer(12,B1m2); SetIndexBuffer(13,B1m3); SetIndexBuffer(14,B1m4); SetIndexBuffer(15,B1m5); SetIndexBuffer(16,B1m6); SetIndexBuffer(17,B1m7);
   SetIndexBuffer(18,B2m0); SetIndexBuffer(19,B2m1); SetIndexBuffer(20,B2m2); SetIndexBuffer(21,B2m3); SetIndexBuffer(22,B2m4); SetIndexBuffer(23,B2m5); SetIndexBuffer(24,B2m6); SetIndexBuffer(25,B2m7);
   SetIndexBuffer(26,B3m0); SetIndexBuffer(27,B3m1); SetIndexBuffer(28,B3m2); SetIndexBuffer(29,B3m3); SetIndexBuffer(30,B3m4); SetIndexBuffer(31,B3m5); SetIndexBuffer(32,B3m6); SetIndexBuffer(33,B3m7);
   SetIndexBuffer(34,B4m0); SetIndexBuffer(35,B4m1); SetIndexBuffer(36,B4m2); SetIndexBuffer(37,B4m3); SetIndexBuffer(38,B4m4); SetIndexBuffer(39,B4m5); SetIndexBuffer(40,B4m6); SetIndexBuffer(41,B4m7);
   IndicatorShortName("Cloud_"+Ma_pr+"_"+Ma);
   switch(Ma_pr){case tied:         ma2=Ma*2.78; ma0=Ma*1.17; ma1=Ma*5.56; ma3=Ma*6.94;break;
                 case proportional: ma2=Ma*2;    ma0=Ma*3;    ma1=Ma*4;    ma3=Ma*5;break;
                 case free:         ma2=Ma*0.5;  ma0=Ma*0.75; ma1=Ma;      ma3=Ma*1.25;break;}
   return (0);
}

int start(){int i,limit=Bars-IndicatorCounted()-1;

   for(i=limit;i>=0;i--){Bp0[i]=(Close[i]-Low[i+1])*1000000;                                                      Bp1[i]=(High[i+1]-Close[i])*1000000;
                         Bp2[i]=(Close[i]-MathMin(Low[i],Close[i+1]))*1000000;                                    Bp3[i]=(MathMax(High[i],Close[i+1])-Close[i])*1000000;
                         Bp4[i]=(Close[i]-MathMin(Low[i],Close[i+1])-(MathMin(Open[i],Close[i])-Low[i]))*1000000; Bp5[i]=(MathMax(High[i],Close[i+1])-Close[i]-(High[i]-MathMax(Open[i],Close[i])))*1000000;
                         Bp6[i]=(Close[i]-((High[i+1]+Low[i+1])/2))*1000000;                                      Bp7[i]=(((High[i+1]+Low[i+1])/2)-Close[i])*1000000;}

   for(i=limit;i>=0;i--){B1m0[i]=iMAOnArray(Bp0,0,ma0,0,0,i); B1m1[i]=iMAOnArray(Bp1,0,ma0,0,0,i); 
                         B1m2[i]=iMAOnArray(Bp0,0,ma1,0,1,i); B1m3[i]=iMAOnArray(Bp1,0,ma1,0,1,i);
                         B1m4[i]=iMAOnArray(Bp0,0,ma2,0,2,i); B1m5[i]=iMAOnArray(Bp1,0,ma2,0,2,i);
                         B1m6[i]=iMAOnArray(Bp0,0,ma3,0,3,i); B1m7[i]=iMAOnArray(Bp1,0,ma3,0,3,i);

                         B2m0[i]=iMAOnArray(Bp2,0,ma0,0,0,i); B2m1[i]=iMAOnArray(Bp3,0,ma0,0,0,i);
                         B2m2[i]=iMAOnArray(Bp2,0,ma1,0,1,i); B2m3[i]=iMAOnArray(Bp3,0,ma1,0,1,i);
                         B2m4[i]=iMAOnArray(Bp2,0,ma2,0,2,i); B2m5[i]=iMAOnArray(Bp3,0,ma2,0,2,i);
                         B2m6[i]=iMAOnArray(Bp2,0,ma3,0,3,i); B2m7[i]=iMAOnArray(Bp3,0,ma3,0,3,i);

                         B3m0[i]=iMAOnArray(Bp4,0,ma0,0,0,i); B3m1[i]=iMAOnArray(Bp5,0,ma0,0,0,i);
                         B3m2[i]=iMAOnArray(Bp4,0,ma1,0,1,i); B3m3[i]=iMAOnArray(Bp5,0,ma1,0,1,i);
                         B3m4[i]=iMAOnArray(Bp4,0,ma2,0,2,i); B3m5[i]=iMAOnArray(Bp5,0,ma2,0,2,i);
                         B3m6[i]=iMAOnArray(Bp4,0,ma3,0,3,i); B3m7[i]=iMAOnArray(Bp5,0,ma3,0,3,i);

                         B4m0[i]=iMAOnArray(Bp6,0,ma0,0,0,i); B4m1[i]=iMAOnArray(Bp7,0,ma0,0,0,i);
                         B4m2[i]=iMAOnArray(Bp6,0,ma1,0,1,i); B4m3[i]=iMAOnArray(Bp7,0,ma1,0,1,i);
                         B4m4[i]=iMAOnArray(Bp6,0,ma2,0,2,i); B4m5[i]=iMAOnArray(Bp7,0,ma2,0,2,i);
                         B4m6[i]=iMAOnArray(Bp6,0,ma3,0,3,i); B4m7[i]=iMAOnArray(Bp7,0,ma3,0,3,i);}

   double bb,hh,hl;
   for(i=limit;i>=0;i--){hh=0;hl=0;
                         bb=B1m0[i]-B1m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m0[i]-B1m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m0[i]-B1m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m0[i]-B1m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m2[i]-B1m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m2[i]-B1m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m2[i]-B1m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m2[i]-B1m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m4[i]-B1m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m4[i]-B1m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m4[i]-B1m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m4[i]-B1m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m6[i]-B1m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m6[i]-B1m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m6[i]-B1m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B1m6[i]-B1m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}

                         bb=B2m0[i]-B2m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m0[i]-B2m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m0[i]-B2m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m0[i]-B2m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m2[i]-B2m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m2[i]-B2m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m2[i]-B2m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m2[i]-B2m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m4[i]-B2m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m4[i]-B2m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m4[i]-B2m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m4[i]-B2m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m6[i]-B2m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m6[i]-B2m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m6[i]-B2m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B2m6[i]-B2m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}

                         bb=B3m0[i]-B3m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m0[i]-B3m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m0[i]-B3m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m0[i]-B3m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m2[i]-B3m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m2[i]-B3m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m2[i]-B3m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m2[i]-B3m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m4[i]-B3m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m4[i]-B3m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m4[i]-B3m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m4[i]-B3m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m6[i]-B3m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m6[i]-B3m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m6[i]-B3m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B3m6[i]-B3m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}

                         bb=B4m0[i]-B4m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m0[i]-B4m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m0[i]-B4m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m0[i]-B4m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m2[i]-B4m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m2[i]-B4m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m2[i]-B4m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m2[i]-B4m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m4[i]-B4m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m4[i]-B4m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m4[i]-B4m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m4[i]-B4m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m6[i]-B4m1[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m6[i]-B4m3[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m6[i]-B4m5[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                         bb=B4m6[i]-B4m7[i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;} B0[i]=hh; B1[i]=hl;}
   return (0);
}