//------------------------------------------------------------------
//
//   divisor modification idea by SwingMan
//   from Mt5 version from Mladen
//
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  C'235,255,235'
#property indicator_color2  C'255,235,235'
#property indicator_color3  clrMediumSeaGreen
#property indicator_color4  clrOrangeRed
#property indicator_color5  clrOrangeRed
#property indicator_color6  clrMediumSeaGreen
#property indicator_color7  clrOrangeRed
#property indicator_color8  clrOrangeRed
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2, // Heiken ashi trend biased (extreme) price
   pr_habclose,   // Heiken ashi (better formula) close
   pr_habopen ,   // Heiken ashi (better formula) open
   pr_habhigh,    // Heiken ashi (better formula) high
   pr_hablow,     // Heiken ashi (better formula) low
   pr_habmedian,  // Heiken ashi (better formula) median
   pr_habtypical, // Heiken ashi (better formula) typical
   pr_habweighted,// Heiken ashi (better formula) weighted
   pr_habaverage, // Heiken ashi (better formula) average
   pr_habmedianb, // Heiken ashi (better formula) median body
   pr_habtbiased, // Heiken ashi (better formula) trend biased price
   pr_habtbiased2 // Heiken ashi (better formula) trend biased (extreme) price
};

input int                 inpPeriod   = 14;           // Hull period
input double              inpDivisorf = 2.2;          // Hull fast "speed"
input double              inpDivisors = 1.8;          // Hull slow "speed"
input enPrices            inpPrice    = pr_close;     // Hull price to use 
input int                 LinesWidth  = 3;            // Lines width 
input int                 FillWidth   = 5;            // Fill width 

double valf[],valfc[],valfDa[],valfDb[],vals[],valsc[],valsDa[],valsDb[],fillu[],filld[]; 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int OnInit()
{
   IndicatorBuffers(10);
   SetIndexBuffer(0,fillu, INDICATOR_DATA);  SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,FillWidth);
   SetIndexBuffer(1,filld, INDICATOR_DATA);  SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,FillWidth);
   SetIndexBuffer(2,valf , INDICATOR_DATA);  SetIndexStyle(2,DRAW_LINE,EMPTY,LinesWidth);
   SetIndexBuffer(3,valfDa,INDICATOR_DATA);  SetIndexStyle(3,DRAW_LINE,EMPTY,LinesWidth);
   SetIndexBuffer(4,valfDb,INDICATOR_DATA);  SetIndexStyle(4,DRAW_LINE,EMPTY,LinesWidth);
   SetIndexBuffer(5,vals,  INDICATOR_DATA);  SetIndexStyle(5,DRAW_LINE,EMPTY,LinesWidth);
   SetIndexBuffer(6,valsDa,INDICATOR_DATA);  SetIndexStyle(6,DRAW_LINE,EMPTY,LinesWidth);
   SetIndexBuffer(7,valsDb,INDICATOR_DATA);  SetIndexStyle(7,DRAW_LINE,EMPTY,LinesWidth);
   SetIndexBuffer(8,valfc, INDICATOR_CALCULATIONS);
   SetIndexBuffer(9,valsc, INDICATOR_CALCULATIONS);

   IndicatorShortName("Hull ribbon ("+(string)inpPeriod+","+(string)inpDivisorf+","+(string)inpDivisors+")");
return(INIT_SUCCEEDED);
}
void OnDeinit(const int reason){   }

//
//
//
//
//

int OnCalculate (const int       rates_total,
                 const int       prev_calculated,
                 const datetime& btime[],
                 const double&   open[],
                 const double&   high[],
                 const double&   low[],
                 const double&   close[],
                 const long&     tick_volume[],
                 const long&     volume[],
                 const int&      spread[])
{
      int i,counted_bars = prev_calculated;
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
            int limit=fmin(rates_total-counted_bars,rates_total-1);
      
      //
      //
      //
      //
      //
      
      if (valfc[limit]==-1) CleanPoint(limit,valfDa,valfDb);
      if (valsc[limit]==-1) CleanPoint(limit,valsDa,valsDb);
      for(i=limit; i>=0; i--)
      {
         double price = getPrice(inpPrice,open,close,high,low,i,rates_total);
         valf[i] = fillu[i] = iHull(price,inpPeriod,inpDivisorf,i,rates_total,0);
         vals[i] = filld[i] = iHull(price,inpPeriod,inpDivisors,i,rates_total,1);
         valfDa[i] = EMPTY_VALUE;
         valfDb[i] = EMPTY_VALUE;
         valsDa[i] = EMPTY_VALUE;
         valsDb[i] = EMPTY_VALUE;
         valfc[i] = valsc[i] = (valf[i]>vals[i]) ? 1 :(valf[i]<vals[i]) ? -1 : (i<rates_total-1) ? valfc[i+1]: 0;
         if (valfc[i]==-1) PlotPoint(i,valfDa,valfDb,valf); 
         if (valsc[i]==-1) PlotPoint(i,valsDa,valsDb,vals);                     
      }
return(rates_total);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _prHABF(_prtype) (_prtype>=pr_habclose && _prtype<=pr_habtbiased2)
#define _priceInstances     1
#define _priceInstancesSize 4
double workHa[][_priceInstances*_priceInstancesSize];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int bars, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= bars) ArrayResize(workHa,bars); instanceNo*=_priceInstancesSize; int r = bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen  = (r>0) ? (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0 : (open[i]+close[i])/2;;
         double haClose = (open[i]+high[i]+low[i]+close[i]) / 4.0;
         if (_prHABF(tprice))
               if (high[i]!=low[i])
                     haClose = (open[i]+close[i])/2.0+(((close[i]-open[i])/(high[i]-low[i]))*fabs((close[i]-open[i])/2.0));
               else  haClose = (open[i]+close[i])/2.0; 
         double haHigh  = fmax(high[i], fmax(haOpen,haClose));
         double haLow   = fmin(low[i] , fmin(haOpen,haClose));

         //
         //
         //
         //
         //
         
         if(haOpen<haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else               { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                              workHa[r][instanceNo+2] = haOpen;
                              workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:
            case pr_habclose:    return(haClose);
            case pr_haopen:   
            case pr_habopen:     return(haOpen);
            case pr_hahigh: 
            case pr_habhigh:     return(haHigh);
            case pr_halow:    
            case pr_hablow:      return(haLow);
            case pr_hamedian:
            case pr_habmedian:   return((haHigh+haLow)/2.0);
            case pr_hamedianb:
            case pr_habmedianb:  return((haOpen+haClose)/2.0);
            case pr_hatypical:
            case pr_habtypical:  return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:
            case pr_habweighted: return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:  
            case pr_habaverage:  return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
            case pr_habtbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
            case pr_habtbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }
   return(0);
}
   
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _hullInstances 2
#define _hullInstancesSize 2
double workHull[][_hullInstances*_hullInstancesSize];
double iHull(double price, double period, double divisor, int r, int bars, int iNo=0)
{
   if(ArrayRange(workHull,0)!=bars) ArrayResize(workHull,bars); r=Bars-r-1;
   iNo*=_hullInstancesSize; workHull[r][iNo]=price;
   if(period<=1) return(price);
   
   //
   //
   //
   //
   //
   
   int HmaPeriod  = (int)fmax(period,2);
   int HalfPeriod = (int)floor(HmaPeriod/divisor);
   int HullPeriod = (int)floor(sqrt(HmaPeriod));
   
   //
   //
   //
   //
   //
   
   double hma,hmw,weight;
   hmw = HalfPeriod; hma = hmw*price;
   for(int k=1; k<HalfPeriod && (r-k)>=0; k++)
   {
      weight = HalfPeriod-k;
      hmw   += weight;
      hma   += weight*workHull[r-k][iNo];
   }
   
   //
   //
   //
   //
   //
   
   workHull[r][iNo+1] = 2.0*hma/hmw;
   hmw = HmaPeriod; hma = hmw*price;
   for(int k=1; k<period && (r-k)>=0; k++)
   {
      weight = HmaPeriod-k;
      hmw   += weight;
      hma   += weight*workHull[r-k][iNo];
   }
   
   //
   //
   //
   //
   //
   
   workHull[r][iNo+1]-=hma/hmw;
   hmw = HullPeriod; hma = hmw*workHull[r][iNo+1];
   for(int k=1; k<HullPeriod && (r-k)>=0; k++)
   {
      weight = HullPeriod-k;
      hmw   += weight;
      hma   += weight*workHull[r-k][1+iNo];
   }
return(hma/hmw);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}
